blob: fb5d6b3918d058b355cf496825ba87783d4af2e5 [file] [log] [blame]
Fam Zheng6b560c72017-09-05 10:11:52 +08001#!/bin/bash
2#
3# Author: Fam Zheng <famz@redhat.com>
4#
5# Archive source tree, including submodules. This is created for test code to
6# export the source files, in order to be built in a different environment,
7# such as in a docker instance or VM.
8#
9# This code is licensed under the GPL version 2 or later. See
10# the COPYING file in the top-level directory.
11
12error() {
13 printf %s\\n "$*" >&2
14 exit 1
15}
16
17if test $# -lt 1; then
18 error "Usage: $0 <output tarball>"
19fi
20
Mao Zhongyi934821e2018-10-15 17:17:34 +080021tar_file=$(realpath "$1")
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020022sub_tdir=$(mktemp -d "${tar_file%.tar}.sub.XXXXXXXX")
23sub_file="${sub_tdir}/submodule.tar"
Fam Zheng6b560c72017-09-05 10:11:52 +080024
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010025# We want a predictable list of submodules for builds, that is
26# independent of what the developer currently has initialized
27# in their checkout, because the build environment is completely
28# different to the host OS.
Marc-André Lureau7c57bdd82019-04-24 13:00:41 +020029submodules="dtc slirp ui/keycodemapdb tests/fp/berkeley-softfloat-3 tests/fp/berkeley-testfloat-3"
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020030sub_deinit=""
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010031
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020032function cleanup() {
33 local status=$?
34 rm -rf "$sub_tdir"
35 if test "$sub_deinit" != ""; then
36 git submodule deinit $sub_deinit
37 fi
38 exit $status
39}
40trap "cleanup" 0 1 2 3 15
Daniel P. Berrange47bb9082017-09-29 11:11:57 +010041
Marc-André Lureau84963b52019-07-09 00:02:49 +040042function tree_ish() {
43 local retval='HEAD'
44 if ! git diff-index --quiet --ignore-submodules=all HEAD -- &>/dev/null
45 then
46 retval=$(git stash create)
47 fi
48 echo "$retval"
49}
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020050
Marc-André Lureau84963b52019-07-09 00:02:49 +040051git archive --format tar "$(tree_ish)" > "$tar_file"
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020052test $? -ne 0 && error "failed to archive qemu"
Philippe Mathieu-Daudéd3b44262019-01-24 02:00:23 +010053for sm in $submodules; do
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020054 status="$(git submodule status "$sm")"
55 smhash="${status#[ +-]}"
56 smhash="${smhash%% *}"
57 case "$status" in
58 -*)
59 sub_deinit="$sub_deinit $sm"
60 git submodule update --init "$sm"
61 test $? -ne 0 && error "failed to update submodule $sm"
62 ;;
63 +*)
64 echo "WARNING: submodule $sm is out of sync"
65 ;;
66 esac
Marc-André Lureau84963b52019-07-09 00:02:49 +040067 (cd $sm; git archive --format tar --prefix "$sm/" $(tree_ish)) > "$sub_file"
Gerd Hoffmann8fc76172019-05-20 14:47:03 +020068 test $? -ne 0 && error "failed to archive submodule $sm ($smhash)"
69 tar --concatenate --file "$tar_file" "$sub_file"
70 test $? -ne 0 && error "failed append submodule $sm to $tar_file"
Philippe Mathieu-Daudéd3b44262019-01-24 02:00:23 +010071done
Fam Zheng6b560c72017-09-05 10:11:52 +080072exit 0